"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var chalk_1 = require("chalk");
var logSymbols = require("log-symbols");
var schema_1 = require("../loaders/schema");
var schema_2 = require("../../diff/schema");
var render_1 = require("../render");
var change_1 = require("../../changes/change");
function hasBreaking(changes) {
    return changes.some(function (c) { return c.criticality.level === change_1.CriticalityLevel.Breaking; });
}
function diff(oldSchemaPointer, newSchemaPointer, options) {
    return __awaiter(this, void 0, void 0, function () {
        var renderer, oldSchema, newSchema, changes, breakingCount, e_1;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    renderer = (options && options.renderer) || new render_1.ConsoleRenderer();
                    _a.label = 1;
                case 1:
                    _a.trys.push([1, 4, , 5]);
                    return [4 /*yield*/, schema_1.loadSchema(oldSchemaPointer)];
                case 2:
                    oldSchema = _a.sent();
                    return [4 /*yield*/, schema_1.loadSchema(newSchemaPointer)];
                case 3:
                    newSchema = _a.sent();
                    changes = schema_2.diff(oldSchema, newSchema);
                    if (!changes.length) {
                        renderer.emit(logSymbols.success, chalk_1.default.greenBright('No changes detected'));
                    }
                    else {
                        renderer.emit("\nDetected the following changes (" + changes.length + ") between schemas:\n");
                        changes.forEach(function (change) {
                            renderer.emit.apply(renderer, render_1.renderChange(change));
                        });
                        if (hasBreaking(changes)) {
                            breakingCount = changes.filter(function (c) { return c.criticality.level === change_1.CriticalityLevel.Breaking; }).length;
                            renderer.emit(chalk_1.default.redBright("\nDetected " + breakingCount + " breaking change" + (breakingCount > 1 ? 's' : '') + "\n"));
                            process.exit(1);
                        }
                        else {
                            renderer.emit(chalk_1.default.greenBright('\nNo breaking changes detected\n'));
                        }
                    }
                    return [3 /*break*/, 5];
                case 4:
                    e_1 = _a.sent();
                    renderer.emit(logSymbols.error, chalk_1.default.redBright(e_1.message || e_1));
                    process.exit(1);
                    return [3 /*break*/, 5];
                case 5:
                    process.exit(0);
                    return [2 /*return*/];
            }
        });
    });
}
exports.diff = diff;
//# sourceMappingURL=diff.js.map