"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function stripBOM(content) {
    content = content.toString();
    // Remove byte order marker. This catches EF BB BF (the UTF-8 BOM)
    // because the buffer-to-string conversion in `fs.readFileSync()`
    // translates it to FEFF, the UTF-16 BOM.
    if (content.charCodeAt(0) === 0xfeff) {
        content = content.slice(1);
    }
    return content;
}
exports.stripBOM = stripBOM;
function parseBOM(content) {
    return JSON.parse(stripBOM(content));
}
exports.parseBOM = parseBOM;
//# sourceMappingURL=string.js.map